/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// file réalisée avec deux piles

#include "prelude.h"
#include "stack.h"
#include "aqueue.h"

struct AQueue {
  stack *front; // où on prend des éléments
  stack *rear;  // où on ajoute des éléments
  int size;
};

aqueue *aqueue_create(void) {
  aqueue *q = malloc(sizeof(struct AQueue));
  q->front = stack_create();
  q->rear = stack_create();
  q->size = 0;
  return q;
}
int aqueue_size(aqueue *q) {
  return q->size;
}
bool aqueue_is_empty(aqueue *q) {
  return q->size == 0;
}
void aqueue_enqueue(aqueue *q, int x) {
  stack_push(q->rear, x);
  q->size++;
}
// si front est vide, on y verse tout rear
void aqueue_check(aqueue *q) {
  if (!stack_is_empty(q->front)) return;
  while(!stack_is_empty(q->rear))
    stack_push(q->front, stack_pop(q->rear));
}
int aqueue_peek(aqueue *q) {
  assert(!aqueue_is_empty(q));
  aqueue_check(q);
  return stack_top(q->front);
}
int aqueue_dequeue(aqueue *q) {
  assert(!aqueue_is_empty(q));
  aqueue_check(q);
  q->size--;
  return stack_pop(q->front);
}
void aqueue_delete(aqueue *q) {
  stack_delete(q->front);
  stack_delete(q->rear);
  free(q);
}

