
type 'a queue = {
  front: 'a list; (* où on prend des éléments *)
   rear: 'a list; (* où on ajoute des éléments *)
}

let empty : 'a queue =
  { front = []; rear = [] }

let is_empty (q: 'a queue) : bool =
  q.front = [] && q.rear = []

let enqueue (q: 'a queue) (x: 'a) : 'a queue =
  { front = q.front; rear = x :: q.rear }

let dequeue (q: 'a queue) : 'a * 'a queue =
  match q.front with
  | x :: f ->
      x, { front = f; rear = q.rear }
  | [] ->
      begin match List.rev q.rear with
      | []     -> invalid_arg "dequeue"
      | x :: f -> x, { front = f; rear = [] }
      end
