/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// tableau (contenant des entiers)
// avec longueur et accès défensif aux cases avec assert

#include "prelude.h"

#include "array.h"

struct Array {
  int size;
  int *data;    // tableau de taille size
};

array *array_create(int n, int x) {
  array *a = malloc(sizeof(struct Array));
  a->size = n;
  a->data = calloc(n, sizeof(int));
  for (int i = 0; i < n; i++) {
    a->data[i] = x;
  }
  return a;
}

int array_size(array *a) {
  return a->size;
}

int array_get(array *a, int i) {
  assert(0 <= i && i < a->size);
  return a->data[i];
}

void array_set(array *a, int i, int x) {
  assert(0 <= i && i < a->size);
  a->data[i] = x;
}

void array_delete(array *a) {
  free(a->data);
  free(a);
}
