/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// pile réalisée avec un tableau (capacité bornée)

#include "prelude.h"

typedef struct ArrStack {
  int capacity;
  int size;     // 0 <= size <= capacity
  int *data;    // tableau de taille capacity
} astack;

astack *astack_create(int c) {
  astack *s = malloc(sizeof(struct ArrStack));
  s->capacity = c;
  s->size = 0;
  s->data = calloc(c, sizeof(int));
  return s;
}

bool astack_is_empty(astack *s) {
  return s->size == 0;
}
bool astack_is_full(astack *s) {
  return s->size == s->capacity;
}

void astack_push(astack *s, int x) {
  assert(!astack_is_full(s));
  s->data[s->size] = x;
  s->size++;
}

int astack_top(astack *s) {
  assert(!astack_is_empty(s));
  return s->data[s->size - 1];
}

int astack_pop(astack *s) {
  assert(!astack_is_empty(s));
  s->size--;
  return s->data[s->size];
}

void astack_delete(astack *s) {
  free(s->data);
  free(s);
}

