
(* Algorithme de la boulangerie de Lamport *)

let n =
  if Array.length Sys.argv = 1 then 5 else int_of_string Sys.argv.(1)

let number = Array.make n 0
let entering = Array.make n false

let lock i =
  entering.(i) <- true;
  number.(i) <- 1 + Math.fold_interval 0 n 0 (fun n j -> max n number.(j));
  entering.(i) <- false;
  for j = 0 to n - 1 do
    while entering.(j) do
      () (* attente active *)
    done;
    while number.(j) <> 0 && (number.(j), j) < (number.(i), i) do
      () (* attente active *)
    done
  done

let unlock i =
  number.(i) <- 0

(* Note : l'instruction `printf` n'est pas atomique.  Sans le
   mécanisme de section critique, les affichages des différentes
   chaînes seraient possiblement mélangés. Il est facile de le
   constater en remplaçant la fonction `lock` ci-dessus par une
   fonction sans effet. *)
let create i =
  lock i;
  Format.printf "section critique du fil %d@." i;
  unlock i

let th = Array.init n (Thread.create create)
let () = Array.iter Thread.join th

