/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// Filtre de Bloom pour des chaînes (char*)

#include "prelude.h"

#ifndef BLOOM
#define BLOOM

typedef struct Bloom bloom;

bloom *bloom_create(int k, int m);
  // k fonctions de hachage et un tableau de m booléens

void bloom_add(bloom *h, char *s);

bool bloom_contains(bloom *b, char *s);

void bloom_delete(bloom *b);

#endif
