
(* Files de priorité immuables

   L'ordre utilisé ici est la comparaison structurelle polymorphe d'OCaml. *)

type 'a heap

val empty: 'a heap

val is_empty: 'a heap -> bool
  (* O(1) *)

val insert: 'a -> 'a heap -> 'a heap
  (* O(log n) *)

val get_min: 'a heap -> 'a
  (* O(1) *)

val extract_min: 'a heap -> 'a * 'a heap
  (* O(log n) *)

val size: 'a heap -> int
  (* O(log n)^2) *)

val iter: ('a -> unit) -> 'a heap -> unit

val fold: ('b -> 'a -> 'b) -> 'b -> 'a heap -> 'b


