type mobile =
  | Objet of int
  | Barre of int * mobile * mobile

let rec masse m = match m with
  | Objet k -> k
  | Barre(k, m1, m2) -> k + masse m1 + masse m2

let rec stable m = match m with
  | Objet _ -> true
  | Barre(_, m1, m2) -> stable m1 && stable m2 && masse m1 = masse m2

let rec stable_opt m = match m with
  | Objet k ->
      k, true
  | Barre(k, m1, m2) ->
      let k1, b1 = stable_opt m1 in
      let k2, b2 = stable_opt m2 in
      k + k1 + k2, b1 && b2 && k1 = k2

exception Instable
let stable_exn m =
  let rec aux (m: mobile): int = match m with
    | Objet k -> k
    | Barre(k, m1, m2) -> let k1 = masse m1 and k2 = masse m2 in
                          if k1 = k2 then
                            k + k1 + k2
                          else
                            raise Instable
  in
  try
    ignore(aux m); true
  with
    Instable -> false
