
(* Ensembles d'entiers dans 0..255, immuables, avec union.

   En alternative à ajouter `union` à `Rbt`, on peut simplifier
   coder de tels ensembles avec des tableaux de 256 booléens. *)

type set = bool array

let empty =
  Array.make 256 false

let mem i s =
  if i < 0 || i > 255 then invalid_arg "mem";
  s.(i)

let singleton i =
  if i < 0 || i > 255 then invalid_arg "mem";
  Array.init 256 (fun j -> j = i)

let union s1 s2 =
  Array.init 256 (fun j -> s1.(j) || s2.(j))
