
(* 3-coloration de graphe par retour sur trace *)

open Graph

(* renvoie une 3-coloration sous la forme d'un tableau contenant 0,1,2 ;
   lève Not_found s'il n'est pas possible de 3-colorier le graphe *)

let color3 g =
  let n = size g in
  let c = Array.make n 0 in
  let rec color i =
    i = n || assign i 0 || assign i 1 || assign i 2
  and assign i v =
    c.(i) <- v;
    List.for_all (fun j -> j >= i || c.(j) <> v) (succ g i) &&
    color (i + 1)
  in
  if color 0 then c else raise Not_found

