
open Graph

let components (g: graph) : int * int array =
  let n = size g in
  let nc = ref 0 in
  let num = Array.make n 0 in
  let visited = Array.make n false in
  let rec dfs v =
    if not visited.(v) then (
      visited.(v) <- true;
      num.(v) <- !nc;
      List.iter dfs (succ g v)
    ) in
  let component v =
    if not visited.(v) then (dfs v; incr nc) in
  for v = 0 to n - 1 do component v done;
  !nc, num

(* avec union-find *)

let components_uf (g: graph) : int * int array =
  let n = size g in
  let uf = Union_find.create n in
  List.iter (fun (u,v) -> Union_find.union uf u v) (edges g);
  let nc = ref 0 in
  let num = Array.make n (-1) in
  let assign_num i =
    let r = Union_find.find uf i in
    if num.(r) = -1 then (num.(r) <- !nc; incr nc);
    num.(i) <- num.(r) in
  for i = 0 to n - 1 do assign_num i done;
  !nc, num
