
(* Graphes orientés, par matrice d'adjacence *)

type graph = bool array array

let size g =
  Array.length g

let create n =
  Array.make_matrix n n false

let add_edge g u v =
  g.(u).(v) <- true

let has_edge g u v =
  g.(u).(v)

let succ g u =
  let l = ref [] in
  for j = 0 to size g - 1 do
    if g.(u).(j) then l := j :: !l
  done;
  !l

let edges g =
  let l = ref [] in
  for i = 0 to size g - 1 do
    for j = 0 to size g - 1 do
      if g.(i).(j) then l := (i, j) :: !l
    done
  done;
  !l


