
(* Plus courts chemins dans un graphe orienté pondéré
   par l'algorithme de Dijkstra *)

val dijkstra: Wdigraph.wdigraph -> int -> float array
(* [dijkstra g source] renvoie un tableau donnant la distance de chaque
   sommet à la source, avec la valeur [infinity] si le sommet n'est
   pas atteignable. *)

val dijkstra_path: Wdigraph.wdigraph -> int -> float array * int array
(* renvoie également un chemin de longueur minimal : pour chaque sommet w,
   on indique le sommet v par lequel il faut passer,
   et la valeur -1 qu'il n'y a pas de chemin *)

val dijkstra_dst: Wdigraph.wdigraph -> int -> int -> int * float * int list
(* [dijkstra_dst g src dst] détermine un plus court chemin entre [src]
   et [dst]. Renvoie le nombre total de sommets insérés dans la file,
   la distance et le chemin. Lève [Not_found] s'il n'y a pas de chemin. *)

