(**************************************************************************)
(*                                                                        *)
(*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       *)
(*  Kim Nguyen, Laurent Sartre                                            *)
(*                                                                        *)
(*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      *)
(*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 *)
(*                                                                        *)
(*  https://www.informatique-mpi.fr/                                      *)
(*                                                                        *)
(**************************************************************************)

(** Reconnaissance d'un mot du langage de Dyck sur {}()[] *)
let closing c =
  match c with
  | '[' -> ']'
  | '(' -> ')'
  | '{' -> '}'
  | _ -> failwith "invalid char"

let dyck s =
  let n = String.length s in
  let rec loop stack i =
    if i = n then stack = []
    else
      match (s.[i], stack) with
      | (('[' | '(' | '{') as c), _ -> loop (c :: stack) (i + 1)
      | (']' | ')' | '}'), [] -> false
      | ((']' | ')' | '}') as c), p :: sstack ->
          c = closing p && loop sstack (i + 1)
      | _ -> false
  in
  loop [] 0
