
open Wdigraph

let floyd_warshall (g: wdigraph) : float array array =
  let n = size g in
  let dist = Array.make_matrix n n infinity in
  List.iter (fun (d, i, j) -> dist.(i).(j) <- d) (edges g);
  for i = 0 to n - 1 do dist.(i).(i) <- 0. done;
  for k = 0 to n - 1 do
    for i = 0 to n - 1 do
      for j = 0 to n - 1 do
        let x = dist.(i).(k) +. dist.(k).(j) in
        if x < dist.(i).(j) then dist.(i).(j) <- x
      done
    done
  done;
  dist

(* exercice *)
let floyd_warshall_path (g: wdigraph) : float array array * int array array =
  let n = size g in
  let dist = Array.make_matrix n n infinity in
  let path = Array.make_matrix n n (-1) in
  let set i j k d = dist.(i).(j) <- d; path.(i).(j) <- k in
  List.iter (fun (d, i, j) -> set i j i d) (edges g);
  for i = 0 to n - 1 do set i i i 0. done;
  for k = 0 to n - 1 do
    for i = 0 to n - 1 do
      for j = 0 to n - 1 do
        let x = dist.(i).(k) +. dist.(k).(j) in
        if x < dist.(i).(j) then set i j k x
      done
    done
  done;
  dist, path

