
(* Plus courts chemins dans un graphe orienté pondéré
   par l'algorithme de Floyd--Warshall *)

val floyd_warshall: Wdigraph.wdigraph -> float array array
 (* [floyd_warshall g] renvoie une matrice donnant la distance
    pour chaque paire de sommets, avec la valeur [infinity] lorsqu'il
    n'existe pas de chemin. *)

val floyd_warshall_path:
  Wdigraph.wdigraph -> float array array * int array array
  (* renvoie également un chemin de longueur minimal : pour chaque paire (i,j),
     on indique le sommet k par lequel il faut passer (la valeur i signifie
     qu'il faut seulement emprunter l'arc, et la valeur -1 qu'il n'y a pas
     de chemin) *)
