
(* Calcul propositionnel

   Les variables sont ici des entiers entre 1 et n.
   Cela permet notamment une représentation facile des littéraux
   (entier i ou -i) et une forme normale (CNF ou DNF) qui est
   directement au format DIMACS.
*)

type binop = And | Or | Imp

type fmla =
  | True
  | False
  | Var of int (* dans 1..n *)
  | Not of fmla
  | Bin of binop * fmla * fmla

val print: Format.formatter -> fmla -> unit

val size: fmla -> int

val subst: int -> fmla -> fmla -> fmla

type valuation = bool array

val eval: valuation -> fmla -> bool

val varmax: fmla -> int

val print_truth_table: Format.formatter -> fmla -> unit

val f_true: fmla
val f_false: fmla
val f_var: int -> fmla
val f_not: fmla -> fmla
val f_or: fmla -> fmla -> fmla
val f_and: fmla -> fmla -> fmla
val f_implies: fmla -> fmla -> fmla
val f_xor: fmla -> fmla -> fmla
val f_equiv: fmla -> fmla -> fmla
