
(* Coloration d'un graphe par un algorithme glouton

   Les sommets sont considérés dans l'ordre donné par la liste `order`. *)

open Graph

(* la plus petite couleur qui n'est pas dans l *)
let min_color (l: int list) : int =
  let n = List.length l in
  let free = Array.make (n + 1) true in
  List.iter (fun v -> free.(v) <- false) l;
  let rec find i = if free.(i) then i else find (i + 1) in
  find 0

let greedy_color (g: graph) (order: int list) : int array =
  let color = Array.make (size g) 0 in
  let assign v =
    let colors = List.map (fun w -> color.(w)) (succ g v) in
    color.(v) <- min_color colors in
  List.iter assign order;
  color
