
(* table de hachage où les clés sont des chaînes et les valeurs de type 'v *)

type 'v hashtable

val create: int -> 'v hashtable
  (* on donne une capacité initiale, à titre indicatif *)

val put: 'v hashtable -> string -> 'v -> unit

val contains: 'v hashtable -> string -> bool

val get: 'v hashtable -> string -> 'v
  (* lève Not_found si la clé n'est pas présente dans la table *)

val remove: 'v hashtable -> string -> unit

val iter: (string * 'v -> unit) -> 'v hashtable -> unit

val print: ('v -> string) -> 'v hashtable -> unit

val hash: string -> int
  (* exportée pour faire des tests de collisions *)

val stat: 'v hashtable -> int array
  (* histogramme de remplissage des seaux *)
