
(* Tri par tas *)

let heapsort a =
  let h = Array.fold_right Skew_heap.insert a Skew_heap.empty in
  let rec fill i h =
    if i < Array.length a then begin
      let x, h = Skew_heap.extract_min h in
      a.(i) <- x;
      fill (i + 1) h
    end in
  fill 0 h

(* tests *)

let () =
  Random.self_init ();
  for n = 0 to 30 do
    let a = Array.init n (fun _ -> Random.int 20) in
    heapsort a;
    for i = 0 to n - 2 do assert (a.(i) <= a.(i + 1)) done
  done




