
(* Algorithme ID3

   On ne considère ici que des arbres de décisions binaires,
   en distinguant les valeurs <= 0 et les valeurs > 0.
*)

type data = float array

type label = int

type dectree

val build: (data * label) array -> dectree

val lookup: dectree -> data -> label

val id3: (data * label) array -> (data -> label)
  (* simple combinaison de `build` et `lookup`
     /!\ faire une application partielle *)

val size: dectree -> int
  (* nombre de noeuds de décision dans l'arbre *)

val print: Format.formatter -> dectree -> unit
