
type 'a stack = 'a list ref

let create () : 'a stack =
  ref []

let is_empty (st: 'a stack) : bool =
  !st = []

let push (st: 'a stack) (x: 'a) : unit =
  st := x :: !st

let top (st: 'a stack) : 'a =
  match !st with
  | [] -> invalid_arg "top"
  | x :: _ -> x

let pop (st: 'a stack) : 'a =
  match !st with
  | [] -> invalid_arg "pop"
  | x :: l -> st := l; x
