let max_list comp l =
  let rec loop l mx =
    match l with
    | [] -> mx
    | v :: ll -> loop ll (if comp v mx > 0 then v else mx)
  in
  match l with [] -> assert false | mx :: ll -> loop ll mx

let max_kadane l =
  let rec loop l l_max =
    match (l, l_max) with
    | [], _ -> max_list compare l_max
    | v :: ll, m :: _ -> loop ll (max v (v + m) :: l_max)
    | _ -> assert false
  in
  loop l [ 0 ]

let kadane l =
  let rec loop l l_max =
    match (l, l_max) with
      [], _ -> max_list (fun (a, _) (b, _) -> compare a b) l_max
    | v :: ll, (m, lm) :: _ ->
      let vm = v + m in
      loop ll ((if v <= vm then (vm,v::lm) else (v,[v]))::l_max)
  | _ -> assert false
  in
  List.rev (snd (loop l [ (0, []) ]))


let () =
  assert (kadane [-2; 1; -3; 4; -1; 2; 1; -5; 4] = [4;-1;2;1])