/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

/* Algorithme des k moyennes. */

#ifndef KMEANS
#define KMEANS

bool kmeans_classify(int k, int d, double *di, double **mea, int *ci);
  // classifie `di` selon les moyennes dans `mea`
  // écrit le résultat dans *ci

double **kmeans(int k, int d, double **data, int n, int *cl);
  /* entrée : `n` données en dimension `d` dans le tableau `data`
              un tableau `cl` de taille `n`
     sortie : une classification 0,...,k-1 dans le tableau 'cl'
              le tableau des `k` moyennes comme résultat */

#endif
