
(* algorithme de Kosaraju--Sharir *)

open Digraph

let kosaraju_sharir (g: digraph) : int * int array =
  let n = size g in
  let nc = ref 0 in
  let num = Array.make n 0 in
  let visited = Array.make n false in
  let rec dfs v =
    if not visited.(v) then (
      visited.(v) <- true;
      num.(v) <- !nc;
      List.iter dfs (succ g v)
    ) in
  let component v =
    if not visited.(v) then (dfs v; incr nc) in
  List.iter component (post_order (mirror g));
  !nc, num
