
(* Algorithme de Kruskal *)

open Wgraph

let kruskal (g: wgraph) : (float * int * int) list =
  let n = size g in
  let uf = Union_find.create n in
  let pq = Pqueue.create () in
  List.iter (Pqueue.insert pq) (edges g);
  let mst = ref [] in
  let size = ref 0 in
  while !size < n - 1 do
    let (_, src, dst) as e = Pqueue.extract_min pq in
    if not (Union_find.find uf src = Union_find.find uf dst)
    then (
      Union_find.union uf src dst;
      mst := e :: !mst;
      size := !size + 1
    )
  done;
  !mst
