
(* Apprentissage

   Ici, les données sont des vecteurs de nombres flottants (type `data`)
   et les classes sont des entiers (type `label`), dans [0..N[.
*)

type data = float array
type label = int

val k_nn: int -> (data * label) array -> data -> label
  (** `k_nn k nc data d` réalise l'algorithme des `k` plus proches voisins,
      avec distance euclidienne. Renvoie la classe trouvée pour `d`.
      L'entier `k` doit être strictement positif ; dans le cas
      contraire, l'exception `Invalid_argument` est levée. *)

val k_nn_tree: int -> (data * label) array -> (data -> label)
  (** Même chose, en utilisant un arbre k-dimensionnel.
      `k_nn_tree k data` renvoie une fonction de classification.
      /!\ Bien faire une application partielle ! *)

val k_means: int -> data array -> data array * label array
  (** `k_means k data` réalise l'algorithme des `k`-moyennes sur les données
      `data`, avec la distance euclidienne, et renvoie une classification
      sous la forme d'un tableau `cl` de même taille que `data`.
      La donnée d'indice `i` dans `data` est classifiée par `cl.(i)`. *)


val dist: float array -> float array -> float
  (** distance euclidienne *)

val plurality: (data * label) array -> label
