/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// Table de hachage
// réalisant un dictionnaire des chaînes (char*) vers les entiers (int)

#include "prelude.h"

#ifndef LPTABLE
#define LPTABLE

typedef struct Lptable lptable;

lptable *lptable_create(int capacity);

int lptable_size(lptable *h);

void lptable_put(lptable *h, char *k, int v);
  // écrase l'entrée précédente pour k, le cas échéant

bool lptable_contains(lptable *h, char *k);

int lptable_get(lptable *h, char *k);
  // renvoie -1 si la clé n'est pas dans la table

void lptable_remove(lptable *h, char *k);

void lptable_stat(lptable *h);

void lptable_print(lptable *h);

void lptable_delete(lptable *h);

#endif
