/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

#include "prelude.h"
#include "math.h"

euclidean math_division(int a, int b) {
  assert(a >= 0 && b > 0);
  int q = 0;
  while (a >= b) {
    a -= b;
    q++;
  }
  euclidean e = { q, a };
  return e;
}

int math_power(int x, int n) {
  int y = 1;
  while (n > 0) {
    if (n % 2 == 1) y *= x;
    x = x * x;
    n = n / 2;
  }
  return y;
}

int math_power_naive(int x, int n) {
  int y = 1;
  for (int i=0; i<n; i++) {
    y *= x;
  }
  return y;
}

uint64_t math_power_mod(uint64_t x, int n, uint64_t m) {
  if (n == 0) return 1;
  uint64_t y = math_power_mod((x * x) % m, n / 2, m);
  return n % 2 == 0 ? y : (y * x) % m;
}

int math_int_sqrt(int n) {
  int r = 0, i = 0;
  while (r <= n) {
    r += 2 * i + 1;
    i++;
  }
  return i - 1;
}
