
(* Quelques fonctions mathématiques.

   Voir aussi le module `Matrix`. *)

val gcd: int -> int ->  int
  (* algorithme d'Euclide *)

val extended_gcd: int -> int -> int * int * int
  (* algorithme d'Euclide étendu ; `extended_gcd u v` renvoie
     un triplet `(x,y,d)` avec x*u + y*v = gcd(u,v) *)

val div_mod: int -> int -> int -> int
  (* `div_mod u v m` divise `u` par `v modulo `m`,
     sous l'hypothèse que `gcd(v, m) = 1` *)

val fact: int -> int
  (* factorielle *)

val power: int -> int -> int
  (* exponentiation rapide *)

val pop: int -> int
  (* population count = nombre de bits 1 en base 2 *)

val print_binary: Format.formatter -> int -> unit
  (* imprime les 63 bits d'un entier *)

val catalan: int -> int array
  (* n-ième nombre de Catalan *)


val exists: int -> int -> (int -> bool) -> bool
val for_all: int -> int -> (int -> bool) -> bool
  (* quantifiers over interval [lo..hi[ *)

val interval: int -> int -> int list
  (* `interval lo hi` renvoie la liste [lo; lo+1; ...; hi-1] *)

val sum_interval: int -> int -> (int -> int) -> int
  (* `sum_interval lo hi f` renvoie la somme des `f i` pour `lo <= i < hi` *)

val fold_interval: int -> int -> 'a -> ('a -> int -> 'a) -> 'a
  (* `fold_interval lo hi acc f` itère la fonction `f` sur tous
     les entiers `lo <= i < hi` *)

val iverson: bool -> int
  (* 1 ou 0, selon le booléen *)
