/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// tableau (contenant des entiers)
// avec longueur et accès défensif aux cases avec assert

#include "prelude.h"

#include "matrix.h"

struct Matrix {
  int rows, cols;
  int **data;    // tableau de taille rows, de tableaux de taille cols
};

matrix *matrix_create(int r, int c, int x) {
  matrix *m = malloc(sizeof(struct Matrix));
  m->rows = r;
  m->cols = c;
  m->data = calloc(r, sizeof(int*));
  for (int i = 0; i < r; i++) {
    m->data[i] = calloc(c, sizeof(int));
    for (int j = 0; j < c; j++) {
      m->data[i][j] = x;
    }
  }
  return m;
}

int matrix_rows(matrix *m) {
  return m->rows;
}
int matrix_cols(matrix *m) {
  return m->cols;
}

int matrix_get(matrix *m, int i, int j) {
  assert(0 <= i && i < m->rows);
  assert(0 <= i && i < m->cols);
  return m->data[i][j];
}

void matrix_set(matrix *m, int i, int j, int x) {
  assert(0 <= i && i < m->rows);
  assert(0 <= i && i < m->cols);
  m->data[i][j] = x;
}

void matrix_print(matrix *m) {
  for (int i = 0; i < m->rows; i++) {
    for (int j = 0; j < m->cols; j++) {
      printf(" %3d", m->data[i][j]);
    }
    printf("\n");
  }
}

void matrix_delete(matrix *m) {
  free(m->data);
  free(m);
}
