
let memo ?(debug=false) ff =
  let h = Hashtbl.create 8192 in
  let hit = ref 0 in
  if debug then at_exit (fun () ->
    Format.eprintf "memo: %d entries, %d hits@." (Hashtbl.length h) !hit);
  let rec f x =
    try let v = Hashtbl.find h x in incr hit; v
    with Not_found -> let v = ff f x in Hashtbl.add h x v; v
  in
  f
