
(* Mémoïsation.

   Utilise en interne une table de hachage, avec l'égalité polymorphe
   et la fonction de hachage polymorphe d'OCaml. *)

val memo: ?debug:bool -> (('a -> 'b) -> ('a -> 'b)) -> 'a -> 'b
  (* `memo ff` renvoie une fonction `f` qui est le point fixe de la
     fonctionnelle `ff`.

     Exemple : au lieu d'écrire     `let rec fib n  = ...`
     il suffit d'écrire `let fib = memo (fun fib n -> ...` *)

