
let rec merge l1 l2 = match l1, l2 with
  | [], l | l, [] ->
      l
  | x1 :: t1, x2 :: t2 ->
      if x1 <= x2 then
        x1 :: merge t1 l2
      else
        x2 :: merge l1 t2

(* une variante qui ne fait pas déborder la pile, pour le tri fusion *)
let rec merge_acc l l1 l2 = match l1, l2 with
  | [], l' | l', [] ->
      List.rev_append l l'
  | x1 :: t1, x2 :: t2 ->
      if x1 <= x2 then
        merge_acc (x1 :: l) t1 l2
      else
        merge_acc (x2 :: l) l1 t2

let rec split l1 l2 = function
  | []     -> l1, l2
  | x :: r -> split l2 (x :: l1) r

let rec mergesort l = match l with
  | [] | [_] ->
      l
  | _ ->
      let l1, l2 = split [] [] l in
      merge_acc [] (mergesort l1) (mergesort l2)

