/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include <pthread.h>
#include <semaphore.h>

int nb_philo = 5;
pthread_mutex_t *stick;
sem_t s;

void *philosopher(void *arg) {
  int i = *((int *)arg);
  printf("Start philosopher %d\n", i);
  while (1) {
    printf("Philosopher %d is thinking\n", i);
    sem_wait(&s);
    pthread_mutex_lock(&stick[i]);
    pthread_mutex_lock(&stick[(i+1) % nb_philo]);
    sem_post(&s);
    printf("Philosopher %d is eating\n", i);
    pthread_mutex_unlock(&stick[(i+1) % nb_philo]);
    pthread_mutex_unlock(&stick[i]);
  }
}

int main(int argc, char **argv) {
  pthread_t *philo = malloc(nb_philo * sizeof(pthread_t));
  int *pid = malloc(nb_philo * sizeof(int));
  sem_init(&s, 0, nb_philo - 1);
  stick = malloc(nb_philo * sizeof(pthread_mutex_t));
  for (int i = 0; i < nb_philo; i++) {
    pid[i] = i;
    pthread_mutex_init(&stick[i], NULL);
    pthread_create(&philo[i], NULL, philosopher, &pid[i]);
  }
  pthread_join(philo[0], NULL);
}
