
open Semaphore
let nb_philo = 5

let stick = Array.init nb_philo (fun _ -> Mutex.create ())
let s = Counting.make (nb_philo - 1)

let philosopher i =
  Format.printf "Start philosopher %d@." i;
  while true do
    Format.printf "Philosopher %d is thinking\n" i;
    Counting.acquire s;
    Mutex.lock stick.(i);
    Mutex.lock stick.((i+1) mod nb_philo);
    Counting.release s;
    Format.printf "Philosopher %d is eating@." i;
    Mutex.unlock stick.((i+1) mod nb_philo);
    Mutex.unlock stick.(i);
  done

let philo = Array.init nb_philo (fun i -> Thread.create philosopher i)

let () = Thread.join philo.(0)
