
(* Tout simplement une référence contenant une file immuable
   (ici un arbre de Braun)

   Une autre solution consisterait à faire la même chose que dans
   pqueue.c, c'est-à-dire un tas dans un tableau redimensionnable. *)

type 'a pqueue = 'a Braun.heap ref

let create () = ref Braun.empty

let is_empty pq = Braun.is_empty !pq

let insert pq x =
  pq := Braun.insert x !pq

let min pq =
  Braun.get_min !pq

let extract_min pq =
  let x, q = Braun.extract_min !pq in
  pq := q;
  x

let size pq =
  Braun.size !pq

let iter f pq =
  Braun.iter f !pq

let fold f acc pq =
  Braun.fold f acc !pq
