
(* Files de priorité mutables

   L'ordre utilisé ici est la comparaison structurelle polymorphe d'OCaml. *)

type 'a pqueue

val create: unit -> 'a pqueue

val is_empty: 'a pqueue -> bool
  (* O(1) *)

val insert: 'a pqueue -> 'a -> unit
  (* O(log n) *)

val min: 'a pqueue -> 'a
  (* O(1) *)

val extract_min: 'a pqueue -> 'a
  (* O(log n) *)

val size: 'a pqueue -> int

val iter: ('a -> unit) -> 'a pqueue -> unit
val fold: ('b -> 'a -> 'b) -> 'b -> 'a pqueue -> 'b

