
(* Producteurs et consommateurs, avec des sémaphores et des mutex *)

let buffer = Queue.create ()
let size = 5
let nb_p = 2
let nb_c = 5

let empty = Semaphore.Counting.make size
let full = Semaphore.Counting.make 0
let m = Mutex.create ()

let producer i =
  while true do
    Semaphore.Counting.acquire empty;
    Mutex.lock m;
    let v = Random.int 100 in
    Printf.printf "Producer %d : %d\n" i v;
    Queue.push v buffer;
    Mutex.unlock m;
    Semaphore.Counting.release full;
    Thread.yield ()
  done

let consumer i =
  while true do
    Semaphore.Counting.acquire full;
    Mutex.lock m;
    let v = Queue.take buffer in
    Printf.printf "Consumer %d : %d\n" i v;
    Mutex.unlock m;
    Semaphore.Counting.release empty;
    Thread.yield ()
  done

let tc = Array.init nb_c (fun i -> Thread.create consumer i)
let tp = Array.init nb_p (fun i -> Thread.create producer i)
let () =
  Array.iter Thread.join tc;
  Array.iter Thread.join tp
