(**************************************************************************)
(*                                                                        *)
(*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       *)
(*  Kim Nguyen, Laurent Sartre                                            *)
(*                                                                        *)
(*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      *)
(*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 *)
(*                                                                        *)
(*  https://www.informatique-mpi.fr/                                      *)
(*                                                                        *)
(**************************************************************************)

(* Programmation dynamique

   Somme maximale dans une pyramide d'entiers
*)

let max_sum_rec a =
  let n = Array.length a - 1 in
  let rec s i j =
    a.(i).(j) + (if i = n
                 then 0
                 else max (s (i+1) j) (s (i+1) (j+1)))
  in s 0 0

let max_sum_mem a =
  let memo = Hashtbl.create 16 in
  let rec s i j = (* 0 <= j <= i <= m *)
    try
      Hashtbl.find memo (i, j)
    with Not_found ->
      let v =
        if i = Array.length a then 0
        else a.(i).(j) + max (s (i+1) j) (s (i+1) (j+1)) in
      Hashtbl.add memo (i, j) v;
      v
  in
  s 0 0

let max_sum_bot a =
  let n = Array.length a in
  let s = Array.make_matrix n n 0 in (* 0 <= j <= i <= n *)
  s.(n - 1) <- a.(n - 1);
  for i = n - 2 downto 0 do
    for j = 0 to i do
      s.(i).(j) <- a.(i).(j) + max s.(i+1).(j) s.(i+1).(j+1)
    done
  done;
  s

let max_sum_bot2 t =
  let n = Array.length t in
  let s = Array.make (n+1) 0 in (* 0 <= i <= n+1 *)
  for i = n - 1 downto 0 do
    for j = 0 to i do
      s.(j) <- t.(i).(j) + max s.(j) s.(j+1)
    done
  done;
  s.(0)

let max_sum_sol a =
  let n = Array.length a in
  let s = max_sum_bot a in
  let rec aux i j = match i with
    | k when k = n-1 -> []
    | _ -> let k = if s.(i+1).(j) < s.(i+1).(j+1) then j+1 else j
           in (i+1, k) :: aux (i+1) k
  in
  (0,0) :: (aux 0 0)
