
(* La file est ici réalisée avec deux piles

   On pourrait également utiliser une liste chaînée (voir queue.c pour
   une implémentation en C) ou encore un tableau redimensionnable utilisé
   circulairement (voir ring_buffer.c). *)

type 'a queue = {
  mutable front: 'a list; (* où on prend des éléments *)
  mutable  rear: 'a list; (* où on ajoute des éléments *)
}

let create () =
  { front = []; rear = [] }

let is_empty q =
  q.front = [] && q.rear = []

let enqueue q x =
  q.rear <- x :: q.rear

let dequeue q =
  if q.front = [] then begin
    q.front <- List.rev q.rear;
    q.rear <- []
  end;
  match q.front with
  | []     -> invalid_arg "dequeue"
  | x :: f -> q.front <- f; x
