
(* Arbres rouge-noir

   réalisant ici un tableau associatif (dictionnaire) pour des
   clés de type 'k et des valeurs de type 'v

   La comparaison est faite sur les clés en utilisant la comparaison
   polymorphe d'OCaml. *)

type ('k, 'v) rbt

val empty: ('k, 'v) rbt

val is_empty: ('k, 'v) rbt -> bool

val add: 'k -> 'v -> ('k, 'v) rbt -> ('k, 'v) rbt

val find: 'k -> ('k, 'v) rbt -> 'v

val min_binding: ('k, 'v) rbt -> 'k * 'v

val remove: 'k -> ('k, 'v) rbt -> ('k, 'v) rbt

val of_array: ('k * 'v) array -> ('k, 'v) rbt
  (** à partir d'un tableau supposé trié dans l'ordre croissant
      (pour les clés) *)

val check: ('k, 'v) rbt -> bool
  (** vérifie la propriété d'arbre rouge et noir (mais pas la propriété
      d'arbre binaire de recherche) *)
