type re = private
    Empty
  | Epsilon
  | Char of char
  | Alt of re * re
  | Concat of re * re
  | Star of re

(* Pretty-printing with UTF-8*)
val pp : Format.formatter -> re -> unit

(* Internal printing *)
val print : Format.formatter -> re -> unit

(* Smart constructors *)
val empty : re
val epsilon : re
val char : char -> re
val alt : re -> re -> re
val concat : re -> re -> re
val star : re -> re

val has_epsilon : re -> bool