/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// graphe non orienté par listes d'adjacence

#include "prelude.h"
#include "graph.h"

#ifndef SGRAPH
#define SGRAPH

typedef struct Sgraph sgraph;

sgraph *sgraph_load(char *file);
int sgraph_size(sgraph *g); // nombre de sommets
int sgraph_index(sgraph *g, char* s);
char *sgraph_name(sgraph *g, int u);
graph *sgraph_graph(sgraph *g);
void sgraph_print(sgraph *g);

void sgraph_delete(sgraph *g);

#endif
