
(* Arbres *)

type 'a tree =
  | N of 'a * 'a tree list

let rec size (N (_, tl): 'a tree) : int =
  1 + size_forest tl

and size_forest (tl: 'a tree list) : int =
  match tl with
  | [] -> 0
  | t :: tl -> size t + size_forest tl

(* ou encore, plus simplement *)
let rec size (N (_, tl)) =
  List.fold_left (fun s t -> s + size t) 1 tl

let rec mirror (N (x, tl)) =
  N (x, mirror_forest [] tl)
and mirror_forest acc tl = match tl with
  | [] -> acc
  | t :: tl -> mirror_forest (mirror t :: acc) tl

let rec preorder (f: 'a -> unit) (N (x, tl): 'a tree) : unit =
  f x;
  List.iter (preorder f) tl

let rec postorder f (N (x, tl)) =
  List.iter (postorder f) tl;
  f x

let rec traverse pre post (N (x, tl)) =
  pre x;
  List.iter (traverse pre post) tl;
  post x

