
type elt = node ref
and node = Root of int | Link of elt

let singleton () = ref (Root 0)

let rec find x = match !x with
  | Root _ -> x
  | Link y -> let rx = find y in x := Link rx; rx

let union x y =
  let x = find x in
  let y = find y in
  if x != y then match !x, !y with
    | Root rx, Root ry ->
        if rx < ry then x := Link y
        else (y := Link x; if rx = ry then x := Root (rx + 1))
    | _ -> assert false
