
(* Structure union-find, avec union pondérée et compression de chemins *)

type uf = {
  link: int array;
  rank: int array;
}

let create (n: int) : uf =
  { link = Array.init n (fun i -> i);
    rank = Array.make n 0; }

let rec find (uf: uf) (i: int) : int =
  let p = uf.link.(i) in
  if p = i then i else (
    let r = find uf p in
    uf.link.(i) <- r;
    r
  )

let union (uf: uf) (i: int) (j: int) : unit =
  let ri = find uf i in
  let rj = find uf j in
  if ri <> rj then
    if uf.rank.(ri) < uf.rank.(rj) then
      uf.link.(ri) <- rj
    else (
      uf.link.(rj) <- ri;
      if uf.rank.(ri) = uf.rank.(rj) then
        uf.rank.(ri) <- uf.rank.(ri) + 1
    )



