
(* tableau redimensionnable *)

type 'a vector

val create: int -> 'a -> 'a vector
(* `create n d` renvoie un nouveau tableau redimensionnable, de
   capacité `n` et de taille 0. La valeur `d` est utilisée pour
   initialiser le tableau interne.

   Attention : si on veut un tableau redimensionnable d'une certaine
   taille, il faut donc utiliser `create` puis `resize`. *)

val size: 'a vector -> int
val get: 'a vector -> int -> 'a
val set: 'a vector -> int -> 'a -> unit
val resize: 'a vector -> int -> unit
val clear: 'a vector -> unit

val iteri: (int -> 'a -> unit) -> 'a vector -> unit

val push: 'a vector -> 'a -> unit
val pop: 'a vector -> 'a
val top: 'a vector -> 'a


